import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

import java.awt.Color;
import java.awt.Graphics;

/**
 * Clase ya definida en Greenfoot
 * Counter that displays a number with a text prefix.
 * 
 * @author Michael Kolling
 * @version 1.0.2
 */
public class Counter extends Actor{

    private static final Color textColor = new Color(10, 80, 40);
    
    private int value;
    public int target;
    private String text;
    private int stringLength;

   /**
    * Constructor. Recibe una cadena y el valor con el que se va a inicializar.
    */ 

    public Counter(String prefix, int val)
    {
        text = prefix;
        stringLength = (text.length() + 2) * 10;
        value=val;
        target=val;
        setImage(new GreenfootImage(stringLength, 16));
        GreenfootImage image = getImage();
        image.setColor(textColor);
        updateImage();
    }
    
    public void act() {
        if(value < target) {
            value++;
            updateImage();
        }
        else if(value > target) {
            value--;
            updateImage();
        }
    }
    /**
     * Aumenta los puntos
     */

    public void add(int score)
    {
        target += score;
    }
    /**
     * Disminuye los puntos
     */

    public void subtract(int score)
    {
        target -= score;
    }
    
    /**
     * Regresa el valor de value
     */

    public int getValue()
    {
        return value;
    }

    /**
     * Make the image
     */
    private void updateImage()
    {
        GreenfootImage image = getImage();
        image.clear();
        image.drawString(text + value, 10, 12);
    }
    
    /**
     * Regresa el valor del target (puntos)
     */
    public int daTarget(){
        return target;
    }

}