import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Clase principal del juego. El jugador puede comer peces. Es controlado por el usuario.
 * 
 * Nora G. Rodriguez Mendoza
 * Mayo 2010
 */
public class Jugador  extends Mover
{
    private int alimento;
    private int vidas;
    private int energia;
   /**
    * Contructor de Jugador
    */
    public Jugador()
    {
    vidas=3;
    energia=70;
    alimento=0;
    }
    /**
     *Act - do whatever the comida2 wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     * 
     * Crea 3 objetos uno de la clase Medusa, otro de Comida y otro de Tiburon.
     */
    public void act() 
    {
      Medusa m =(Medusa) getOneIntersectingObject(Medusa.class);
      Comida gn =(Comida) getOneIntersectingObject(Comida.class);
      Tiburon tib =(Tiburon) getOneIntersectingObject(Tiburon.class);
       int aux=0; 
        nada();
        
       if(tib!=null){
        tiburonCome();
       
        }
       
        if(m!=null){
         chocaConMedusa(m);
        }
       
        if(gn!= null){
             comePeces(gn);
         }
         
         if(alimento>=100){
          aux=aux+alimento;
          masEnergia();
         }
         
          if(energia<=0){ 
              quitaVida();
          }
           
           if(vidas==0)
           ((Mar) getWorld()).gameOver();
   }
    /**
     * Metodo para que el pez se mueva por el escenario segun lo quiera el usuario.
     * Utilizando las teclas de direccion.
     */
    public void nada()
    {
       if (Greenfoot.isKeyDown("left")){
           turn(-5);
        }
        if (Greenfoot.isKeyDown("right")){
         turn(5);
        }
         if (Greenfoot.isKeyDown("up")){
         move(5);
        }
         
     }
     
     /**
      * Aumenta el valor de alimento y llama al metodo suma de Mar para mostrarlo en el escenario.
      */
     public void comePeces(Comida c){
            c.muero();
            alimento=alimento+c.daPuntos();
         ((Mar) getWorld()).suma(c.daPuntos());  
        
       }
       /**
        * Impulsa al jugador a direccion contraria de la medusa cuando estos chocan.
        * Decrementa el valor de energia obteniendo el valor de lo que resta la medusa.
        * Llama un metodo para que el valor de energia pueda ser mostrado en pantalla.
        */
       public void chocaConMedusa(Medusa med){
          move(-100);
          turn(180);
          energia=energia-med.resta();
          Greenfoot.playSound("pop.wav");
         ((Mar) getWorld()).menos(med.resta());  
       }
       
       /**
        * Regresa el valor de energia.
        */
        public int daEnergia(){return energia;}
        /**
        * Regresa el valor de alimento.
        */
        public int daComida(){return alimento; }
        /**
        * Regresa el valor de vidas.
        */
        public int daVidas(){return vidas; }
       
        /**
         * Aumenta la energia en 10 cuando.
         * Llama a metodo que permite mostrar la energia en pantalla.
         * Reinicia alimento a 0.
         */
        public void masEnergia()
        {   
            energia=energia+10;
            ((Mar) getWorld()).masE(10);
            alimento=0;
        }
     
     /**
      * Decrementa vidas en uno.
      * Regresa el valor de energia a como estaba originalmete que es 70.
      * Llama a metodo que permite remover objeto de la clase vida.
      */ 
      public void quitaVida()
      {
        vidas=vidas-1;
         energia=70;
         ((Mar) getWorld()).muere();
       }
       /**
        * Regresa al jugador a la posicion con la que inicio cuando choca con el tiburon.
        * Decrementa en uno a vidas.
        */
       
       public void tiburonCome()
       {
           move(-300);
           turn(180);
           Greenfoot.playSound("explosion.wav");
           vidas=vidas-1;
           ((Mar) getWorld()).muere();
       }
}
